include "globals.mzn";

%definition des variables
int : nb_quille = 10;
int : nb_lancers = 22;

set of int: QUILLES = 0..nb_quille;

array [1..10] of var 0..10 : scores;
array [1..10] of var 0..20 : bonus;
array [1..nb_lancers] of var QUILLES: lancers;
int : score_final;


%contraintes 

%contrainte sur le score
constraint score_final <= 300 /\ score_final >= 0;

constraint forall(i in 1..10)(
        (lancers[i*2-1] + lancers[i*2] <= 10 /\ lancers[i*2-1] + lancers[i*2] >= 0)
); 
                

%contraint sur les scores selon les lancers

% Dans le cas d'un trou
constraint forall(i in 1..10)(
          if (lancers[i*2-1] + lancers[i*2]) < 10 then (scores[i] = lancers[i*2-1] + lancers[i*2] /\ bonus[i] = 0)   endif
          
);

% Dans le cas d'un spare
constraint forall(i in 1..9)(
          if (lancers[i*2-1] + lancers[i*2] == 10 /\ lancers[i*2-1] != 10) then (scores[i] = (lancers[i*2-1] + lancers[i*2]) /\ bonus[i] = lancers[i*2+1]) endif
);

% Dans le cas du strike
constraint forall(i in 1..9)(         
          lancers[i*2-1] == 10 -> scores[i] = lancers[i*2-1] /\ (
          (bonus[i]  = lancers[i*2+1] + lancers[i*2+2] -> lancers[i*2+1] != 10) \/
          (bonus[i]  = lancers[i*2+1] + lancers[i*2+3] -> lancers[i*2+1] == 10 )
         )
);

%% contraintes liés au 10ème coup 
% cas d'un strick au 10 ème coup
constraint if lancers[19] == 10 then scores[10] = lancers[19] /\ bonus[10] = lancers[21] + lancers[22] endif;

%
constraint if lancers[19] + lancers[20] != 10 then lancers[21] = 0 /\ lancers[22]=0 endif;
%

% cas d'un spare
constraint if lancers[19] + lancers[20] == 10 /\ lancers[19] != 10 then  lancers[22] = 0 /\ scores[10] = lancers[19] + lancers[20] /\ bonus[10] =  lancers[21] endif;


% calcul du score final 
constraint score_final = sum(scores) + sum(bonus);

solve::int_search(lancers, first_fail, indomain_max,complete) satisfy;
%solve satisfy;

output["Tableau de score: \n"];

output [  
    show(scores[i]) ++ 
    if i == 10 then "\n\n" else " " endif | i in 1..10
];

output [ "Tableau de bonus: \n" ];

output [
    show(bonus[i]) ++ 
    if i == 10 then "\n\n" else " " endif | i in 1..10
];

output [ "Tableau de lancers: \n" ];

output [
    show(lancers[i]) ++ 
    if i == 22 then "\n" else " " endif | i in 1..nb_lancers
];


output [
    
    "\nScore = " ++ show(sum(scores) + sum(bonus) ) ++ "\n"
];